/****************************************************************************************

		I3DExPhotometricProfile.h

		Copyright: (c) 2009 DAZ Productions Corp. All rights reserved.

		I3DExPhotometricProfile definition

		Author:	Pierre-Sylvain
		Date:	11/10/09

*****************************************************************************************/

#ifndef __I3DEXPHOTOMETRICPROFILE__
#define __I3DEXPHOTOMETRICPROFILE__

#if CP_PRAGMA_ONCE
#pragma once
#endif

#include "IExtension.h"
#include "APITypes.h"
#include "InterfaceIDs.h"


//****** Globally Unique Ids *************************************************

MCDEFINE_GUID_H(IID_I3DExPhotometricProfile);

/*****************************************************************************\
*  I3DExPhotometricProfile                                                    *
*                                                                             *
*  Light Sources Photometric Profile                                          *
*                                                                             *
\*****************************************************************************/
/// \addtogroup ExternalInterface
///
/// \{

struct I3DExPhotometricProfile : public IMCUnknown
{
	virtual void		MCCOMAPI SetTransform(const TTransform3D& transform) = 0;
	virtual MCCOMErr	MCCOMAPI GetProfile(const TVector3& direction, TMCColorRGB& result) = 0;
};

/// \}

#endif // __I3DEXPHOTOMETRICPROFILE__
